unit U_QryBaseList;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.ToolWin, cxGraphics,
  cxControls, cxLookAndFeels, cxLookAndFeelPainters, dxSkinsCore,U_WindowFormdesign,
  dxSkinsDefaultPainters, dxSkinWXI, cxStyles, cxCustomData, cxFilter, cxData,
  cxDataStorage, cxEdit, cxNavigator, dxDateRanges, dxScrollbarAnnotations,
  Data.DB, cxDBData, cxGridLevel, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxClasses, cxGridCustomView, cxGrid, Data.Win.ADODB,math,
  dxBarBuiltInMenu, cxGridCustomPopupMenu, cxGridPopupMenu, cxCheckBox,
  cxContainer, dxCore, cxDateUtils, dxLayoutcxEditAdapters, dxLayoutContainer,
  cxMaskEdit, cxDropDownEdit, cxCalendar, cxTextEdit, dxLayoutControl,
   Datasnap.DBClient, cxMemo, Vcl.StdCtrls, Vcl.ExtCtrls,
  cxGeometry, dxFramedControl, dxPanel, FrameDateSel10, dxSkinBasic,
  dxSkinBlack, dxSkinBlue, dxSkinBlueprint, dxSkinCaramel, dxSkinCoffee,
  dxSkinDarkroom, dxSkinDarkSide, dxSkinDevExpressDarkStyle,
  dxSkinDevExpressStyle, dxSkinFoggy, dxSkinGlassOceans, dxSkinHighContrast,
  dxSkiniMaginary, dxSkinLilian, dxSkinLiquidSky, dxSkinLondonLiquidSky,
  dxSkinMcSkin, dxSkinMetropolis, dxSkinMetropolisDark, dxSkinMoneyTwins,
  dxSkinOffice2007Black, dxSkinOffice2007Blue, dxSkinOffice2007Green,
  dxSkinOffice2007Pink, dxSkinOffice2007Silver, dxSkinOffice2010Black,
  dxSkinOffice2010Blue, dxSkinOffice2010Silver, dxSkinOffice2013DarkGray,
  dxSkinOffice2013LightGray, dxSkinOffice2013White, dxSkinOffice2016Colorful,
  dxSkinOffice2016Dark, dxSkinOffice2019Black, dxSkinOffice2019Colorful,
  dxSkinOffice2019DarkGray, dxSkinOffice2019White, dxSkinPumpkin, dxSkinSeven,
  dxSkinSevenClassic, dxSkinSharp, dxSkinSharpPlus, dxSkinSilver,
  dxSkinSpringtime, dxSkinStardust, dxSkinSummer2008, dxSkinTheAsphaltWorld,
  dxSkinTheBezier, dxSkinValentine, dxSkinVisualStudio2013Blue,
  dxSkinVisualStudio2013Dark, dxSkinVisualStudio2013Light, dxSkinVS2010,
  dxSkinWhiteprint, dxSkinXmas2008Blue, MovePanel;

type
  TfrmQryBaseList = class(TForm)
    ToolBar3: TToolBar;
    Trefresh: TToolButton;
    Tprint: TToolButton;
    TprintGrid: TToolButton;
    TsaveGrid: TToolButton;
    Tclose: TToolButton;
    cxGrid1: TcxGrid;
    tv1: TcxGridDBTableView;
    cxGrid1Level1: TcxGridLevel;
    DataSource1: TDataSource;
    ADOQueryList: TADOQuery;
    cxGridPopupMenu1: TcxGridPopupMenu;
    ADOQueryBaseCmd: TADOQuery;
    ADOQueryBaseTemp: TADOQuery;
    tv1SSel: TcxGridDBColumn;
    dxLayoutControl_query: TdxLayoutControl;
    dxLayoutControl_queryGroup_Root: TdxLayoutGroup;
    frmFrameDateSel1: TfrmFrameDateSel10;
    CDS_List: TClientDataSet;
    Panel_page: TPanel;
    BTNP: TButton;
    LBCPAP: TLabel;
    BTLP: TButton;
    TCBNOR: TcxComboBox;
    Label31: TLabel;
    TgridSet: TToolButton;
    cxProgressBar1: TMovePanel;
    toolzdy1: TToolButton;
    toolzdy2: TToolButton;
    toolzdy3: TToolButton;
    toolzdy4: TToolButton;
    toolzdy5: TToolButton;
    toolzdy6: TToolButton;
    toolzdy7: TToolButton;
    toolzdy8: TToolButton;
    toolzdy9: TToolButton;
    toolzdy10: TToolButton;
    toolzdy11: TToolButton;
    toolzdy12: TToolButton;
    toolzdy13: TToolButton;
    toolzdy14: TToolButton;
    toolzdy15: TToolButton;
    toolzdy16: TToolButton;
    toolzdy17: TToolButton;
    toolzdy18: TToolButton;
    toolzdy19: TToolButton;
    toolzdy20: TToolButton;
    procedure TrefreshClick(Sender: TObject);
    procedure TprintClick(Sender: TObject);
    procedure TprintGridClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TcloseClick(Sender: TObject);
    procedure TsaveGridClick(Sender: TObject);
    procedure BTLPClick(Sender: TObject);
    procedure BTNPClick(Sender: TObject);
    procedure TCBNORPropertiesChange(Sender: TObject);
    procedure dxLayoutControl_queryDblClick(Sender: TObject);
    procedure TgridSetClick(Sender: TObject);
  private
    fWindowDesign: TWindowFormdesign;
    CurrentPage, RecordsNumber: Integer;
    fDesignCode:string;
    procedure doQuery();
    procedure doQueryByCriteria();
    procedure initGrid();
  protected
    fParameters1: string;
    fParameters2: string;
    fParameters3: string;
    fParameters4: string;
    fParameters5: string;
    fParameters10: string;
  public
    fFormId: integer;
    fProcedureName:string; //存储过程名称
    FLMType:string;   //报表文件类型标志
    ftimeType:string; //日期类型
    fQueryType:String; //查询类型
    FFiltration1:string; //打印参数条件
    fCriteria:string;   //条件参数
    constructor Create(AOwner: TComponent; ACaption: string=''; Parameters1: string=''; Parameters2: string=''; Parameters3: string=''; Parameters4: string=''; Parameters5: string=''; Parameters10: string='';FormID:Integer=0);

  end;

var
  frmQryBaseList: TfrmQryBaseList;

implementation
uses
  U_RTFun, U_globalVar, U_dataLink,U_FormLayOutDesign, U_LabelPrint,U_cxGridCustomSet;
{$R *.dfm}

procedure TfrmQryBaseList.BTLPClick(Sender: TObject);
begin
  if CurrentPage > 1 then
    CurrentPage := CurrentPage - 1;
  doQuery();
end;

procedure TfrmQryBaseList.BTNPClick(Sender: TObject);
begin
  if CurrentPage < cds_List.FieldByName('TotalCount').AsInteger / RecordsNumber then
    CurrentPage := CurrentPage + 1;
  doQuery();
end;

constructor TfrmQryBaseList.Create(AOwner: TComponent; ACaption: string=''; Parameters1: string=''; Parameters2: string=''; Parameters3: string=''; Parameters4: string=''; Parameters5: string=''; Parameters10: string='';FormID:Integer=0);
begin
  inherited Create(AOwner);
  if ACaption <> '' then
    Caption := ACaption;

  fParameters1 := Parameters1;
  fParameters2 := Parameters2;
  fParameters3 := Parameters3;
  fParameters4 := Parameters4;
  fParameters5 := Parameters5;
  fParameters10 := Parameters10;
  fFormId:=   FormID ;
end;

procedure TfrmQryBaseList.TCBNORPropertiesChange(Sender: TObject);
begin
  RecordsNumber := StrToInt(TCBNOR.Text);
  CurrentPage := 1;
  initGrid();
end;

procedure TfrmQryBaseList.TcloseClick(Sender: TObject);
begin
   close;
end;

procedure TfrmQryBaseList.TgridSetClick(Sender: TObject);
begin
  fWindowDesign.OpenGridDesignWin10(fDesignCode,'cxgrid1',tv1);
end;

procedure TfrmQryBaseList.TprintClick(Sender: TObject);
begin
  if cds_List.IsEmpty then
    Exit;
  TcxGridToExcel(self.Caption, cxgrid1);
end;

procedure TfrmQryBaseList.TprintGridClick(Sender: TObject);
begin
  if cds_List.IsEmpty then
    Exit;
  if trim(self.FLMType)='' then
  begin
    application.MessageBox('未设置打印报表类型,请先设置!','提示信息',0);
    exit;
  end;
  try
    frmLabelPrint := TfrmLabelPrint.Create(Application);
    with frmLabelPrint do
    begin
      FLMType := self.FLMType;
      FFiltration1 := self.FFiltration1;
      if ShowModal = 1 then
      begin
//        Self.InitGrid();
      end;
    end;
  finally
    frmLabelPrint.Free;
  end;
end;

procedure TfrmQryBaseList.TrefreshClick(Sender: TObject);
begin
  if frmFrameDateSel1.BegDate.Visible then
  begin
    frmFrameDateSel1.BegDate.SetFocus;
  end;
  CurrentPage := 1;
  initGrid();
end;

procedure TfrmQryBaseList.TsaveGridClick(Sender: TObject);
begin
  WriteCxGrid(trim(self.Caption) + 'Tv1', Tv1, gDllFileCaption);
  if gIsCanDesign then
  begin
    saveLayOut(application, dxLayoutControl_query, ADOQueryBaseCmd,PWideChar( fDllFileName + '|' + Self.Name + '|' + dxLayoutControl_query.Name + '.ini'));
  end;
end;

////////////////////////////////////
procedure TfrmQryBaseList.doQuery();
var
  strwhere: string;
begin
  if fProcedureName='' then
  begin
    application.MessageBox('存储过程名称参数不能为空!','警告信息',0);
    exit;
  end;
  strwhere := GetProcedureParam(dxLayoutControl_query);

   try
     Tv1.BeginUpdate();
     CDS_List.DisableControls;
     with ADOQueryList do
     begin
       close;
       Filtered := false;
       sql.Clear;
       sql.Add('exec '+fProcedureName);
       sql.Add('@timeType='+quotedstr(fTimeType));
       sql.Add(',@begDate='+quotedstr(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.begdate.Date)));
       sql.Add(',@endDate='+quotedstr(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.enddate.Date+1)));
       if frmFrameDateSel1.jqModel.Checked then
         sql.Add(',@jqModel=1')
       else
         sql.Add(',@jqModel=0');
       if Panel_page.Visible then
       begin
         sql.Add(',@pageIndex=' + inttostr(CurrentPage));
         sql.Add(',@pageSize=' + inttostr(RecordsNumber));
       end;
       sql.Add(',@criteria='+ quotedstr(fcriteria));
       if strwhere<>'' then
         sql.Add(','+strwhere);
        //  showMessage(sql.Text);
       //cxMemo1.Text:=  sql.Text ;
       open;
     end;
     SCreateCDS(ADOQueryList, CDS_List);
     SInitCDSData(ADOQueryList, CDS_List);
     if Panel_page.Visible then
     begin
       LBCPAP.Caption := inttostr(CurrentPage) + '/' + inttostr(ceil(cds_list.FieldByName('TotalCount').AsInteger / RecordsNumber));
     end;
   finally
      CDS_List.EnableControls;
      Tv1.EndUpdate;
   end;
end;

////////////////////////////////////
procedure TfrmQryBaseList.doQueryByCriteria();
var
  mSqlWhere: string;
begin
  if fProcedureName='' then
  begin
    application.MessageBox('存储过程名称参数不能为空!','警告信息',0);
    exit;
  end;

   mSqlWhere := SLGetFilters(dxLayoutControl_query, 1, 2);
   if trim(mSqlWhere) <> '' then
   begin
      mSqlWhere := ' and ' + trim(mSqlWhere);
   end;
   mSqlWhere:=fCriteria + ' ' + mSqlWhere   ;
   try
     Tv1.BeginUpdate();
     CDS_List.DisableControls;
     with ADOQueryList do
     begin
       close;
       Filtered := false;
       sql.Clear;
       sql.Add('exec '+fProcedureName);
       sql.Add('@timeType='+quotedstr(fTimeType));
       sql.Add(',@begDate='+quotedstr(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.begdate.Date)));
       sql.Add(',@endDate='+quotedstr(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.enddate.Date+1)));
       if Panel_page.Visible then
       begin
         sql.Add(',@pageIndex=' + inttostr(CurrentPage));
         sql.Add(',@pageSize=' + inttostr(RecordsNumber));
       end;
       sql.Add(',@criteria='+ quotedstr(mSqlWhere));

       //cxMemo1.Text:=  sql.Text ;
       open;
     end;
     SCreateCDS(ADOQueryList, CDS_List);
     SInitCDSData(ADOQueryList, CDS_List);
     if Panel_page.Visible then
     begin
       LBCPAP.Caption := inttostr(CurrentPage) + '/' + inttostr(ceil(cds_list.FieldByName('TotalCount').AsInteger / RecordsNumber));
     end;
   finally
      CDS_List.EnableControls;
      Tv1.EndUpdate;
   end;
end;
procedure TfrmQryBaseList.dxLayoutControl_queryDblClick(Sender: TObject);
begin
  layoutDesign(TdxLayoutControl(Sender),ADOQueryBaseCmd,PWideChar(dcode));
end;

///
procedure TfrmQryBaseList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Sendmessage(application.MainForm.Handle, WM_CloseForm, 4, 0);

  Action:=cafree;
end;

procedure TfrmQryBaseList.FormCreate(Sender: TObject);
var
  mFontSize:integer;
begin
   getSystemIni();
    if gFontSize<9 then
    begin
      mFontSize := 12;
    end
    else
    begin
      mFontSize:=gFontSize ;
    end;

  self.Font.Size := gFontSize;
  if trim(gFontName)<>'' then
    self.Font.Name:=gFontName;

  cxgrid1.Align:=alClient;
  CurrentPage := 1;
  RecordsNumber := 500;
  fWindowDesign := TWindowFormdesign.Create();
  frmFrameDateSel1.begdate.Date:=SGetServerDate(ADOQueryBaseTemp);
  frmFrameDateSel1.enddate.Date:=frmFrameDateSel1.begdate.Date;
end;

procedure TfrmQryBaseList.FormDestroy(Sender: TObject);
begin
  fWindowDesign.free;
end;

procedure TfrmQryBaseList.FormShow(Sender: TObject);
begin
  fDesignCode := fDllFileName +'|'+self.name+ '|' + intTostr(fformId) + '|' + 'cxgrid1';
  if DParameters8<>'1' then
  begin
    fWindowDesign.FormStyleInit10(self, fFormId, ADOQueryBaseTemp, ADOQueryBaseCmd, '', fParameters10);
  end;
   TgridSet.Visible:=gIsCanDesign;
  if dxLayoutControl_query.Tag<>999 then
    readLayOut(dxLayoutControl_query,ADOQueryBaseTemp,PWideChar( fDllFileName+'|'+self.name+'|'+dxLayoutControl_query.Name+'.ini'));
  fWindowDesign.fProcedureName:=fProcedureName;
  CreateCxGridColumn( Tv1,ADOQueryBaseTemp,PWideChar(fdesignCode));
  //增加动态条件
  addQryContionByLay(ADOQueryBaseTemp,fformId,'cxgrid1',dxLayoutControl_query,7);
  ReadCxGrid(trim(self.Caption) + 'Tv1', Tv1, gDllFileCaption);
  initGrid();
end;

///////////////////////////////
///
procedure TfrmQryBaseList.initGrid();
begin
  if fProcedureName='' then exit;
  try
     cxProgressBar1.Visible:=true;
     cxProgressBar1.Refresh ;

    if fQueryType='criteria' then
    begin
       doQueryByCriteria() ;
    end
    else
    begin
      frmFrameDateSel1.jqModel.Checked:=true;
      doQuery() ;
    end;

  finally
      cxProgressBar1.Visible:=false;
  end;


end;
end.
